def odd_divisors(n):
    string = ''
    for i in range(1, n + 1):
        if n % i == 0:
            if i % 2 is not 0:
                string = string + str(i) + ' '
    return string


# print(odd_divisors(60))


def tribonacci(n):
    a, b, c = 0, 1, 1
    string = ''
    for i in range(n):
        string += str(a) + ' '
        a, b, c = b, c, a + b + c
    return string


# print(tribonacci(10))


def number_of_digits(n):
    if n > 0 and type(n) == int:
        return len(str(n))


# print(number_of_digits(780))


def revert_string(n):
    revert = ''
    for i in n:
        revert = i + revert
    return revert


# print(revert_string('kombajn'))


def from_dec_to_bin(n):
    binar = ''
    if n == 0:
        binar = '0'
    else:
        while n > 0:
            if n % 2 == 0:
                binar = '0' + binar
            else:
                binar = '1' + binar
            n = n // 2
    return binar


# print(from_dec_to_bin(0))

########################################################################
#               Nasleduje kod testu                                    #
########################################################################

ib113_odd_entries = [1, 2, 3, 4, 8, 9, 75, 99, 100]
ib113_odd_results = ["1", "1", "1 3", "1", "1", "1 3 9", "1 3 5 15 25 75",
                     "1 3 9 11 33 99", "1 5 25"]


def ib1113_extract_spaces(string):
    result = ""
    for letter in string:
        if letter != " ":
            result += letter
    return result


def ib113_test_odd_divisor():
    print("Testovani funkce odd_divisor: ", end="")
    failure = False

    for i in range(len(ib113_odd_entries)):
        res = odd_divisors(ib113_odd_entries[i])
        if not isinstance(res, str):
            failure = True
            print("NOK")
            print("Nebyla vracena hodnota typu retezec, ale typu %s" %
                  type(res))
            break
        if ib1113_extract_spaces(res) != \
                ib1113_extract_spaces(ib113_odd_results[i]):
            failure = True
            print("NOK")
            print("Pro hodnotu %s nebyl vracen spravny retezec" %
                  ib113_odd_entries[i])
            print("Byl navracen retezec: %s" % res)
            print("Byl ocekavan retezec: %s" % ib113_odd_results[i])
            break

    if not failure:
        print("OK")


ib113_tribonacci_entries = [0, 1, 2, 3, 10, 15]
ib113_tribonacci_results = ["", "0", "0 1", "0 1 1", "0 1 1 2 4 7 13 24 44 81",
                            "0 1 1 2 4 7 13 24 44 81 149 274 504 927 1705"]


def ib113_test_tribonacci():
    print("\nTestovani funkce test_tribonacci: ", end="")
    failure = False

    for i in range(len(ib113_tribonacci_entries)):
        res = tribonacci(ib113_tribonacci_entries[i])
        if not isinstance(res, str):
            failure = True
            print("NOK")
            print("Nebyla vracena hodnota typu retezec, ale typu %s" %
                  type(res))
            break
        if ib1113_extract_spaces(res) != \
                ib1113_extract_spaces(ib113_tribonacci_results[i]):
            failure = True
            print("NOK")
            print("Pro hodnotu %s nebyl vracen spravny retezec" %
                  ib113_tribonacci_entries[i])
            print("Byl navracen retezec: %s" % res)
            print("Byl ocekavan retezec: %s" % ib113_tribonacci_results[i])
            break

    if not failure:
        print("OK")


ib113_number_of_digits_entries = [1, 11, 999, 1000, 99999, 100000]
ib113_number_of_digits_results = [1, 2, 3, 4, 5, 6]


def ib113_test_number_of_digits():
    print("\nTestovani funkce number_of_digits: ", end="")
    failure = False

    for i in range(len(ib113_number_of_digits_entries)):
        res = number_of_digits(ib113_number_of_digits_entries[i])
        if not isinstance(res, int):
            failure = True
            print("NOK")
            print("Nebyla vracena hodnota typu int, ale typu %s" %
                  type(res))
            break
        if res != ib113_number_of_digits_results[i]:
            failure = True
            print("NOK")
            print("Pro hodnotu %s nebyl vracen spravny vysledek" %
                  ib113_number_of_digits_entries[i])
            print("Byla vracena hodnota: %s" % res)
            print("Byla ocekavana hodnota: %s" %
                  ib113_number_of_digits_results[i])
            break

    if not failure:
        print("OK")


ib113_test_revert_string_entries = ["", "a", "ab", "aba", "bba", " b", "abc"]
ib113_test_revert_string_results = ["", "a", "ba", "aba", "abb", "b ", "cba"]


def ib113_test_revert_string():
    print("\nTestovani funkce revert_string: ", end="")
    failure = False

    for i in range(len(ib113_test_revert_string_entries)):
        res = revert_string(ib113_test_revert_string_entries[i])
        if not isinstance(res, str):
            failure = True
            print("NOK")
            print("Nebyla vracena hodnota typu str, ale typu %s" %
                  type(res))
            break
        if res != ib113_test_revert_string_results[i]:
            failure = True
            print("NOK")
            print("Pro retezec %s nebyl vracen spravny vysledek" %
                  ib113_test_revert_string_entries[i])
            print("Byla vracen retezec: \"%s\"" % res)
            print("Byla ocekavan retezec: \"%s\"" %
                  ib113_test_revert_string_results[i])
            break

    if not failure:
        print("OK")


ib113_from_dec_to_bin_entries = [0, 1, 2, 3, 7, 8, 9, 16, 32, 1024, 2047]
ib113_from_dec_to_bin_results = ["0", "1", "10", "11", "111", "1000", "1001",
                                 "10000", "100000", "10000000000",
                                 "11111111111"]


def ib113_test_from_dec_to_bin():
    print("\nTestovani funkce from_dec_to_bin: ", end="")
    failure = False

    for i in range(len(ib113_from_dec_to_bin_entries)):
        res = from_dec_to_bin(ib113_from_dec_to_bin_entries[i])
        if isinstance(res, int):
            res = str(res)
        if not isinstance(res, str):
            failure = True
            print("NOK")
            print("Nebyla vracena hodnota typu int ani str, ale typu %s" %
                  type(res))
            break
        if res != ib113_from_dec_to_bin_results[i]:
            failure = True
            print("NOK")
            print("Pro hodnotu %s nebyl vracen spravny vysledek" %
                  ib113_from_dec_to_bin_entries[i])
            print("Byla vracena hodnota: \"%s\"" % res)
            print("Byla ocekavana hodnota: \"%s\"" %
                  ib113_from_dec_to_bin_results[i])
            break

    if not failure:
        print("OK")


# Zde muzete vkladat vlastni testy
if __name__ == '__main__':
    ib113_test_odd_divisor()
    ib113_test_tribonacci()
    ib113_test_number_of_digits()
    ib113_test_revert_string()
    ib113_test_from_dec_to_bin()
