"""
Convert a periodic part of a number to a simple fraction. We only consider
numbers in format 0.x, where x are periodic digits (repeating its values at
regular intervals)

Input Format
Integer numbers n that represents a periodic part of a number. For example, if
we have number 0,888888888888... then the input is 8, if we have number
0,741741741741741741... then the input is 741

Constraints
1 < n <= 99999

Output Format
Returns the string that contains the simple fraction. The string format is
<numerator>/<denominator>.

Sample Input 0
81

Sample Output 0
9/11

Explanation 0
81 means the number 0,81818181818181...
1x = 0,81818181818181...
100x = 81,81818181818181...
--------------------------
99x = 81
x = 81/99 = 9/11

Hint: http://www.lektormatematiky.cz/tip04.html
"""

def periodic_to_fraction(period):
    seznam = []
    for i in range(1,int(10**len(str(period))) + 1):
        if period % i == 0 and (10**len(str(period))-1) % i == 0:
            seznam.append(i)
    delitel = max(seznam)
    vysledek = str(period//delitel) + '/' + str((10**len(str(period))-1)//delitel)
    return vysledek

#print(periodic_to_fraction(9))

########################################################################
#               Tests                                                  #
########################################################################

ib113_inputs = [9, 81, 325, 90, 135, 98, 432]
ib113_outputs = ["1/1", "9/11", "325/999", "10/11", "5/37", "98/99", "16/37"]


def ib113_test_periodic_to_fraction():
    count = 0
    length = len(ib113_inputs)

    for i in range(length):
        res = periodic_to_fraction(ib113_inputs[i])

        if not isinstance(res, str) or res != ib113_outputs[i]:
            count += 1

    if count == 0:
        print("OK. All tests passed.")
    else:
        print("Wrong answer. Only %d / %d of tests passed." %
              (length - count, length))


if __name__ == '__main__':
    ib113_test_periodic_to_fraction()
