"""
Implement the function which describes the decomposition of the number n to
prime numbers and presents their powers separated by space (e.g. 2^3 3^2 5^1)

Input Format
Integer numbers n

Constraints
1 < n <= 9999

Output Format
Returns the string that contains powers of prime numbers. Results of
multiplication of these powers should be equal to n.

Sample Input 0
294

Sample Output 0
2^1 3^1 7^2

Explanation 0
2^1 * 3^1 * 7^2 = 2 * 3 * 49 = 6 * 49 = 294
"""

def power_factorization(n):
    x = n
    seznam = []
    list = [0]*(n+1)
    for i in range(2,n+1):
        while n % i == 0:
            seznam.append(i)
            n = n / i
    for i in seznam:
        list[i] += 1
    retezec = ''
    for i in range(x+1):
        if list[i] != 0:
            retezec += str(i)+'^'+str(list[i]) + ' '
    return retezec

#power_factorization(1709)

########################################################################
#               Tests                                                  #
########################################################################

ib113_inputs = [2, 7, 25, 42, 294, 360, 1024]
ib113_outputs = ["2^1", "7^1", "5^2", "2^1 3^1 7^1", "2^1 3^1 7^2",
                 "2^3 3^2 5^1", "2^10"]


def ib113_extract_last_space(string):
    if len(string) < 1:
        return string

    if string[len(string) - 1] == " ":
        return string[:-1]
    return string


def ib113_test_power_factorization():
    count = 0
    length = len(ib113_inputs)

    for i in range(length):
        res = ib113_extract_last_space(power_factorization(ib113_inputs[i]))

        if res is None:
            count += 1
        elif not isinstance(res, str) or res != ib113_outputs[i]:
            count += 1

    if count == 0:
        print("OK. All tests passed.")
    else:
        print("Wrong answer. Only %d / %d of tests passed." %
              (length - count, length))


if __name__ == '__main__':
    ib113_test_power_factorization()
