"""
Count how many leap years were between two given years.

Input Format
Two integer numbers n and m.

Constraints
1500 <= n <= 2100
1500 <= m <= 2100

Output Format
Return the integer value of the leap years in given range.

Sample Input 0
2008, 2032

Sample of Returned Value 0
7

Explanation 0
Leap years between 2008 and 2032 are 2008, 2012, 2016, 2020, 2024, 2028, 2032.

"""


def leap_year(starting, ending):
    count = 0
    if ending < starting:
        return count
    for i in range(starting, ending + 1):
        if i % 4 == 0:
            count += 1
        if i % 100 == 0 and i % 400 != 0:
            count += -1
    return count


########################################################################
#               Tests                                                  #
########################################################################

ib113_inputs = [(2000, 1998), (2008, 2032), (1500, 2100), (1999, 2001),
                (1899, 1901), (1900, 2000), (1982, 2017)]
ib113_outputs = [0, 7, 146, 1, 0, 25, 9]


def ib113_test_leap_year():
    count = 0
    length = len(ib113_inputs)

    for i in range(length):
        res = leap_year(ib113_inputs[i][0], ib113_inputs[i][1])

        if not isinstance(res, int) or res != ib113_outputs[i]:
            count += 1

    if count == 0:
        print("OK. All tests passed.")
    else:
        print("Wrong answer. Only %d / %d of tests passed." %
              (length - count, length))


if __name__ == '__main__':
    ib113_test_leap_year()
