"""
You are given a string S. Your task is to capitalize each word of S that
follows dot symbol and one space. Moreover, the first letter should be
capitalized as well.

Input Format
String S.

Constraints
- 0 <= len(S) < 1000
- The string consists of alphanumeric characters, spaces, dots and commas.

Note: in a word only the first character is capitalized. Example 12abc when
capitalized remains 12abc.

Output Format
Return the capitalized string S.

Sample Input 0
hello world. i love you.

Sample of Returned Value 0
Hello world. I love you.
"""


def capitalize(string):
    if len(string) == 0:
        return string
    if '.' in string and string.index('.') < len(string) - 1:
        string1 = string[:string.index('.') + 2] + string[string.index('.')
                                                          + 2].upper() \
                  + string[string.index('.') + 3:]
    else:
        string1 = string

    return string1[0].upper() + string1[1:]


########################################################################
#               Tests                                                  #
########################################################################

ib113_inputs = ["",
                "a",
                "A",
                "Ahoj.",
                "ahoj.",
                "1",
                ".",
                "picture removal detract earnest is by. esteems met joy "
                "attempt way clothes yet demesne tedious. 1replying an "
                "marianne do it an entrance advanced. two dare say play "
                "when hold. required bringing me material stanhill jointure "
                "is as he. mutual indeed yet her living result matter him "
                "bed whence."
                ]
ib113_outputs = ["",
                 "A",
                 "A",
                 "Ahoj.",
                 "Ahoj.",
                 "1",
                 ".",
                 "Picture removal detract earnest is by. Esteems met joy "
                 "attempt way clothes yet demesne tedious. 1replying an "
                 "marianne do it an entrance advanced. Two dare say play "
                 "when hold. Required bringing me material stanhill jointure "
                 "is as he. Mutual indeed yet her living result matter him "
                 "bed whence."]


def ib113_test_capitalize():
    count = 0
    length = len(ib113_inputs)

    for i in range(length):
        res = capitalize(ib113_inputs[i])
        if not isinstance(res, str) or res != ib113_outputs[i]:
            count += 1

    if count == 0:
        print("OK. All tests passed.")
    else:
        print("Wrong answer. Only %d / %d of tests passed." %
              (length - count, length))


if __name__ == '__main__':
    ib113_test_capitalize()
