# ################################## HW6 ################################## #
"""
Pokyny:
- Deadline odevzdani: 21. 12. 23:59
- Odevzdejte jediny soubor
    - Student - IB113 - Odevzdavarny - Skupina 01 (pripadne 02) - DU 6
- Muzete si vytvaret pomocne funkce, pokud chcete.
- V pripade, ze chcete vytvaret vlastni testy, vkladete je na prislusne misto
    na konci souboru.
    - Pred odevzdanim vlastni modifikace smazte.
- Piste srozumitelny kod, pouzivejte vhodne nazvy promennych a funkci.
- Dodrzujte standard pep8.
    - Budu kontrolovat a strhavat body za jeho nedodrzeni.
- Nemente hlavicky pripravenych funkci.
- Pripadne nejasnosti muzete resit v diskuznim foru. Pokud by ale mela otazka
    obsahovat kusy kodu, nebo neco, co by mohli ostatni studenti opsat, tak
    napiste radeji email.
- Pokud nevite, jak nejaky priklad vyresit kompletne, napiste do komentare,
    co vasemu reseni chybi.
- Neopisujte. Nestoji to za to. Dostanete zaporne body a budete muset ulohu
    stejne vypracovat sami.

Implementujte uvedene funkce dle jejich dokumentace. Prvni z nich nacita
externi soubor do interni datove struktury typu slovnik a zbyvajici funkce nad
nim pracuji (pocitaji ruzne statistiky)
"""

# Funkce nacte data ze souboru jmena.csv a ulozi je do slovniku. Soubor se
# musi nachazet ve stejnem adresari jako soubor s domacim ukole. Struktura
# nacitanych dat je dana csv formatem.
# Vytvoreny slovnik ma strukturu dat ve formatu dct[jmeno][rok], kde jmeno je
# typu str a rok typu int, tj. napr. dct["ANNA"][2000] obsahuje hodnotu 1382

import pandas as pd


def load_data_to_dictionary():
    csv_file = pd.read_csv('jmena.csv')
    data = {}
    for i in range(len(csv_file['JMÉNO'])):
        data[csv_file['JMÉNO'][i]] = {}
        for n in range(1950, 2014):
            data[csv_file['JMÉNO'][i]][n] = int(csv_file[str(n)][i])
    return data


# Naleznete n nejpopularnejsich jmen pro dany rok

# :param dct:   slovnik v jehoz datech vyhledavame vysledky
# :param n:     pocet jmen, ktera se maji vratit
# :param year:  rok ve kterem hledame nejpopularnejsi jmena

# :return       seznam obsahujici n nejpopularnejsich jmen v roce year
def n_most_popular_for_given_year(dct, n, year):
    dct_of_year = {}
    for i in dct.keys():
        if i != 'JMÉNO' and i != 'SOUČET':
            dct_of_year[i] = dct[i][year]
    sort = sorted(dct_of_year.keys(), key=dct_of_year.get, reverse=True)
    return sort[:n]


# Naleznete kdy bylo dane jmeno nejpopularnejsi

# :param dct:   slovnik v jehoz datech vyhledavame vysledky
# :param name:  jmeno, ktere hledame v datech.

# :return       rok (int), ve kterem bylo dane jmeno nejpopularnejsi v pripade,
#               ze se ve slovniku nachazi. Jinak vraci None
def most_popular_in_what_year(dct, name):
    if name not in dct.keys():
        return None
    for i in range(1950, 2014):
        if dct[name][i] == max(dct[name].values()):
            return i


# Funkce nalezne rok, kdy u daneho jmena doslo k nejvetsimu vzrustu popularity
# Tato funkce uvazuje vzrust popularity v absolutnich cislech (nikoliv
# percentualne)

# :param dct:   slovnik v jehoz datech vyhledavame vysledky
# :param name   jmeno, ktere zkoumame
# :return year  cele cislo udavajici rok, po nemz doslo k nejvetsimu vzrustu
#               popularity pro dane jmeno name
def maximal_increase(dict, name):
    if name not in dict.keys():
        return None
    increase = 0
    count = 1950
    value = dict[name][1950]
    for i in dict[name].values():
        if i - value > increase:
            increase = i - value
            year = count - 1
        value = i
        count += 1
    return year


# Funkce nalezne mezi kterymi lety doslo u libovolneho jmena k nejvetsimu
# procentnimu poklesu popularity. Uvazuji se jen jmena, ktera byla dany rok
# davana alespon min-occurence krat (po poklesu mohla klesnout i pod tuto
# hranici. Funkce vraci dvojici (jmeno, rok), kde rok je rok po kterem doslo
# k nejvetsimu poklesu pro dane jmeno

# :param dct:   slovnik v jehoz datech vyhledavame vysledky
# :param min_occurence  pocet vyskytu daneho jmena, tak aby mohl byt uvazovan
#                       jeho procentni pokles
# :return   (name, year, decrease), kde jmeno je typu str a rok typu int.
#           Rok je rok po kterem doslo k nejvetsimu poklesu pro dane jmeno
#           decrease je typu int a jedna se o percentuelni pokles zaokrouhleny
#           na cele cislo
def maximal_decrease(dict, min_occurence):
    decrease = 1
    for n in dict.keys():
        count = 1950
        value = dict[n][1950]
        for i in dict[n].values():
            if value >= min_occurence:
                if value / i > decrease:
                    decrease = value / i
                    year = count - 1
                    name = n
            value = i
            count += 1
    decrease = 100 - 100 * decrease ** (-1)
    return (name, year, round(decrease))


# Funkce nalezne a vrati seznam jmen, ktera zazila dany rok nejvetsi narust
# popularity oproti predchozimu roku (prvni misto seznamu tedy bude mit jmeno
# jenz zazilo nejvetsi narust popularity dle poctu vyskytu v roce 1951 oproti
# roku 1950, druhe pak narust v roce 1952 oproti roku 1951, ...

# :param dct:   slovnik v jehoz datech vyhledavame vysledky
# :return lst   seznam obsahuji jmena ktera zazila nejvetsi narust popularity
#               oproti predchozimu roku (pocinaje rokem 1951)
def max_increase_for_each_year(dict):
    list_of_max = []
    for i in range(1951, 2014):
        increase = 0
        for n in dict.keys():
            if n != 'SOUČET':
                if dict[n][i] - dict[n][i - 1] > increase:
                    increase = dict[n][i] - dict[n][i - 1]
                    name = n
        list_of_max.append(name)
    return list_of_max


########################################################################
#               Nasleduje kod testu,                                   #
########################################################################


def ib113_test_load_data_to_dictionary(dct):
    print("************* TEST LOAD DATA TO DICTIONARY *************")

    if not isinstance(dct, dict):
        print("NOK: Nebyla vracena promenna typu slovnik")
        return False

    input_data = [("IVAN", 1960), ("ANNA", 2000), ("ALENA", 1982),
                  ("DAVID", 1950), ("EVA", 2010), ("HANA", 2001),
                  ("ALENA", 1990), ("BARBORA", 1982)]
    output_data = [668, 1382, 1146, 9, 358, 504, 547, 1044]
    failure = False

    for i in range(len(input_data)):
        try:
            res = dct[input_data[i][0]][input_data[i][1]]
        except KeyError:
            print("NOK, data pravdepodobne nemaji spravnou strukturu. Nebylo "
                  "mozne ziskat data pro dotaz dictionary[%s][%d]" %
                  (input_data[i][0], input_data[i][1]))
            failure = True
            break

        if not isinstance(res, int):
            failure = True
            print("NOK, Nebyla vracena hodnota typu retezec, ale typu %s" %
                  type(res))
            failure = True
            break
        if res != output_data[i]:
            failure = True
            print("NOK: Data nemaji spravnou strukturu nebo nenacitaji data "
                  "koretne. Pro jmeno %s a rok %d byl vracem vysledek %d, ale"
                  " byl ocekavan vysledek %d" %
                  (input_data[i][0], input_data[i][1], res, output_data[i]))
            failure = True
            break

    if failure:
        return False
    print("OK")
    return True


def ib113_test_n_most_popular_for_given_year(dct):
    print("************* TEST N_MOST_POPULAR_FOR_GIVEN_YEAR *************")
    failure = False

    input_data = [(5, 1982), (10, 1982), (3, 2001)]
    output_data = [['JAN', 'PETR', 'MARTIN', 'LUCIE', 'TOMÁŠ'],
                   ['JAN', 'PETR', 'MARTIN', 'LUCIE', 'TOMÁŠ', 'JANA', 'JIŘÍ',
                    'MICHAL', 'PETRA', 'LENKA'], ['JAN', 'TOMÁŠ', 'JAKUB']]

    for i in range(len(input_data)):
        res = n_most_popular_for_given_year(dct, input_data[i][0],
                                            input_data[i][1])

        if not isinstance(res, list):
            failure = True
            print("NOK: Nebyla vracena hodnota typu list, ale typu %s" %
                  type(res))
            break
        if res != output_data[i]:
            failure = True
            print("NOK: Pro rok %d a pocet jmen %d byl vracen list %s, ale byl"
                  " ocekavan list %s" % (input_data[i][0], input_data[i][1],
                                         res, output_data[i]))
            break

    if not failure:
        print("OK")


def ib113_test_most_popular_in_what_year(dct):
    print("************* TEST MOST_POPULAR_IN_WHAT_YEAR *************")
    failure = False

    input_data = ["ABC", "DAVID", "EVA", "HANA", "ALENA", "BARBORA"]
    output_data = [None, 1979, 1955, 1956, 1955, 1993]

    for i in range(len(input_data)):
        res = most_popular_in_what_year(dct, input_data[i])

        if output_data[i] is None:
            if res is not None:
                failure = True
                print("NOK: Mela byt vracena hodnota None, ale byla vracena"
                      " jina hodnota typu %s)" % type(res))
                break
            continue

        if not isinstance(res, int):
            failure = True
            print("NOK: Pro jmeno %s nebyla vracena hodnota typu int, ale "
                  "typu %s" % (input_data[i], type(res)))
            break
        if res != output_data[i]:
            failure = True
            print("NOK: Pro jmeno %s byl vracen rok %d, ale byl ocekavan rok "
                  "%d." % (input_data[i], res, output_data[i]))
            break

    if not failure:
        print("OK")


def ib113_test_maximal_increase(dct):
    print("************* TEST MAXIMAL_INCREASE *************")
    failure = False

    input_data = ["ABC", "DAVID", "EVA", "HANA", "ALENA", "BARBORA"]
    output_data = [None, 1973, 1962, 1953, 1952, 1987]

    for i in range(len(input_data)):
        res = maximal_increase(dct, input_data[i])

        if output_data[i] is None:
            if res is not None:
                failure = True
                print("NOK: Mela byt vracena hodnota None, ale byla vracena"
                      " jina hodnota typu %s)" % type(res))
                break
            continue

        if not isinstance(res, int):
            failure = True
            print("NOK: Pro jmeno %s nebyla vracena hodnota typu int, ale "
                  "typu %s" % (input_data[i], type(res)))
            break
        if res != output_data[i]:
            failure = True
            print("NOK: Pro jmeno %s byl vracen rok %d, ale byl ocekavan rok "
                  "%d." % (input_data[i], res, output_data[i]))
            break

    if not failure:
        print("OK")


def ib113_test_maximal_decrease(dct):
    print(
        "************* TEST MAXIMAL_DECREASE *************")
    failure = False

    input_data = [50, 100, 400, 500, 1000]
    output_data = [("RADOMÍRA", 1971, 88), ("RADOMÍRA", 1971, 88),
                   ("ANETA", 2012, 63), ("ANETA", 2012, 63),
                   ("VOJTĚCH", 2012, 60)]

    for i in range(len(input_data)):
        res = maximal_decrease(dct, input_data[i])

        if not isinstance(res, tuple):
            failure = True
            print("NOK: Nebyla vracena hodnota typu tuple, ale typu %s" %
                  type(res))
            break

        if not isinstance(res[0], str) or not isinstance(res[1], int) or \
                not isinstance(res[2], int):
            failure = True
            print("NOK: Nebyla vracena hodnota typu tuple(str, int, int), ale "
                  "typu tuple(%s, %s, %s)" % (
                      type(res[0]), type(res[1]), type(res[2])))
            break

        if res[0] != output_data[i][0] or res[1] != output_data[i][1] or \
                res[2] != output_data[i][2]:
            failure = True
            print("NOK: Pro minimalne pocet jmen %d bylo vraceno jmeno %s, "
                  "rok %d a pokles %d, ale bylo ocekavano jmeno %s, rok %d "
                  "a pokles %d." % (
                      input_data[i], res[0], res[1], res[2], output_data[i][0],
                      output_data[i][1], output_data[i][2]))
            break

    if not failure:
        print("OK")


def ib113_test_max_increase_for_each_year(dct):
    print("************* TEST MAX_INCREASE_FOR_EACH_YEAR *************")
    failure = False

    output_data = ["JIŘÍ", "JIŘÍ", "ALENA", "MIROSLAV", "ZDENĚK", "JANA",
                   "LUBOŠ", "DANA", "PETR", "PETR", "IVA", "PAVEL", "PAVEL",
                   "IVANA", "PAVLÍNA", "PETRA", "MARTIN", "MARTIN", "RADEK",
                   "MARTIN", "MARTIN", "RADKA", "MAREK", "PETRA", "TOMÁŠ",
                   "PETRA", "KATEŘINA", "MICHAELA", "LUKÁŠ", "LUCIE", "LUCIE",
                   "VERONIKA", "LUKÁŠ", "JAKUB", "LUCIE", "VERONIKA", "LUCIE",
                   "TOMÁŠ", "TEREZA", "JAKUB", "DAVID", "DANIEL", "KRISTÝNA",
                   "DOMINIK", "DOMINIK", "KRISTÝNA", "TEREZA", "DOMINIK",
                   "MATĚJ", "NATÁLIE", "ELIŠKA", "ADAM", "MATĚJ", "ADAM",
                   "ADAM", "JAKUB", "ADAM", "MATYÁŠ", "MATYÁŠ", "VOJTĚCH",
                   "SOFIE", "MATYÁŠ", "NEZJIŠTĚNO"]

    res = max_increase_for_each_year(dct)
    if not isinstance(res, list):
        failure = True
        print("NOK: Nebyla vracena hodnota typu list, ale typu %s" %
              type(res))
    elif len(res) != len(output_data):
        failure = True
        print("NOK: Seznam ma delku %d ale je ocekavana delka %d" % (
            len(res), len(output_data)))
    else:
        for i in range(len(res)):
            if res[i] != output_data[i]:
                failure = True
                print(
                    "NOK: Pro rok %d bylo vraceno jmeno %s, ale bylo ocekavano"
                    " jmeno %s" % (i + 1951, res[i], output_data[i]))
                break

    if not failure:
        print("OK")


# Hlavni funkce volana automaticky po spusteni programu.
if __name__ == '__main__':
    dct = load_data_to_dictionary()
    if ib113_test_load_data_to_dictionary(dct):
        ib113_test_n_most_popular_for_given_year(dct)
        ib113_test_most_popular_in_what_year(dct)
        ib113_test_maximal_increase(dct)
        ib113_test_maximal_decrease(dct)
        ib113_test_max_increase_for_each_year(dct)
